#ifndef RAM_HH
#define RAM_HH

#include <vm68k/types.h>
#include <vm68k/memory.h>
#include <vm68k/processor.h>

using namespace vm68k ;

class RAM : public memory
{
public:
    RAM ( uint32_type startAddr , uint32_type memorySize , bool debug = false ) ;
    virtual ~RAM () ;

    virtual int get_8(uint32_type address, function_code fc) const ;
    virtual uint16_type get_16(uint32_type address, function_code fc) const ;
    virtual uint32_type get_32(uint32_type address, function_code fc) const ;
    virtual void put_8(uint32_type address, int value, function_code fc) ;
    virtual void put_16(uint32_type address, uint16_type value, function_code fc) ;
    virtual void put_32(uint32_type address, uint32_type value, function_code fc) ;

    virtual uint32_type getLowestAddr ()
        { return startAddr ; } ;
    virtual uint32_type getHighestAddr ()
        { return ( startAddr + memorySize - 1 ) ; } ;

private:
    unsigned char * memory ;
    uint32_type     memorySize ;
    uint32_type     startAddr ;
    bool            debug ;
    
} ;


#endif


