-- types.vhd
--
-- Global type and constant definitions.
--

library ieee ;
use ieee . std_logic_1164 . all ;
use ieee . std_logic_arith . all ;
use ieee . std_logic_unsigned . all ;

package m68k_types is

    -- Register types
    subtype byte_register is std_logic_vector ( 7 downto 0 ) ;
    subtype word_register is std_logic_vector ( 15 downto 0 ) ;
    subtype dword_register is std_logic_vector ( 31 downto 0 ) ;


    -- ALU internal operation codes
    type alu_internal_op_type is
        ( ALU_INT_OR , ALU_INT_AND , ALU_INT_SUB , ALU_INT_ADD ,
        ALU_INT_EOR , ALU_INT_CMP , ALU_INT_REV_SUB , ALU_INT_REV_CMP ) ;

end package m68k_types ;


