

#include "ea_optimisation.h"

/** Notify
 * 
 * This method is called with every possible opcode containing an
 * effective address field within the program. It allows the effective
 * address decoder to be optimised to remove unused addressing modes.
 */
void EA_Optimisation :: Notify ( unsigned opcode , char subtype )
{
    int     mode ;

    if ( subtype == 'E' )
    {
        /* Regular effective address, occupying bits 5 down to 0 */
        /* What's the addressing mode? */
        mode = (( opcode >> 3 ) & 7 ) ;
    } else if ( subtype == 'M' )
    {
        /* Move destination effective address, occupying bits 11 down to 6 */

        /* What's the addressing mode? */
        mode = (( opcode >> 6 ) & 7 ) ;
    } else {
        /* Unknown subtype */
        assert ( 0 ) ;
    }

    Add_Assert ( mode , 3 ) ;
}


