#ifndef SETTINGS_H
#define SETTINGS_H

class Settings
{
public:
    Settings ( const char * ini_file ) ;
    virtual ~Settings () ;

    void Set_Required_Opcode_File ( const char * fn ) ;


    const char * Get_Output_Filename ()
        { return output_filename ; } ;
    const char * Get_Opcode_Map_Filename ()
        { return opcode_map_filename ; } ;
    const char * Get_State_Machine_Directory ()
        { return state_machine_directory ; } ;
    const char * Get_Root_VHDL_Input_Filename ()
        { return root_vhdl_input_filename ; } ;
    const char * Get_VHDL_Input_Directory ()
        { return vhdl_input_directory ; } ;
    const char * Get_Initial_State_Machine ()
        { return initial_state_machine ; } ;
    int Get_Verbose_Level ()
        { return verbose_level ; } ;
    const char * Get_Required_Opcode_File () ;


private:
    const char *    output_filename ;
    const char *    opcode_map_filename ;
    const char *    state_machine_directory ;
    const char *    root_vhdl_input_filename ;
    const char *    vhdl_input_directory ;
    const char *    initial_state_machine ;
    const char *    required_opcode_file ;
    int             verbose_level ;

    struct Variable_Table
    {
        const char * var_name ;
        const char ** var_ptr ;
        bool required ;
    } ;
} ;


#endif



