
#ifndef STATE_MACHINE_LOADER_H
#define STATE_MACHINE_LOADER_H

#include <set>

#include "state.h"
#include "state_machine.h"



typedef set<State_Machine *> State_Machine_Set ;
typedef State_Machine_Set :: iterator State_Machine_Set_Iterator ;

typedef map<string , State_Machine * , Strings_Less> Provides_Map ;
typedef Provides_Map :: iterator Provides_Map_Iterator ;


class State_Machine_Loader
{
public:
    State_Machine_Loader () { is_finalised = false ; } ;
    virtual ~State_Machine_Loader () ;

    void Require_Microsub ( const char * sub_name ) ;
    void Require_Microsubs ( Label_Set list ) ;
    void Add_State_Machine ( const char * filename ) ;
    void Add_State_Machine_Directory ( const char * dir ) ;

    State_Machine * Build_Master_Machine ( const char * root_sub_name ) ;

    State_Machine * Get_State_Machine_For_Name ( const char * sub_name ) ;

private:
    Provides_Map        provides_map ;
    State_Machine_Set   machines ;
    State_Machine_Set   required_machines ;
    bool                is_finalised ;
    State_Machine *     master_machine ;
} ;



#endif

